Apachectl -v, fedora 29, error

#1

Seems a recent update in Fedora may have broken certbot. From https://src.fedoraproject.org/rpms/httpd/tree/f29, the file apachectl.sh says it was updated.
commit b86b48c4a2a3293c0e9a8cb74e01f1827c3be904
Author: Joe Orton jorton@redhat.com
Date: Thu Mar 14 10:30:15 2019 +0000

apachectl: **cleanup and replace script wholesale** (#1641237)
 * drop "apachectl fullstatus" support
 * run systemctl with --no-pager option
 * implement graceful&graceful-stop by signal directly
run "httpd -t" from legacy action script
Resolves: rhbz#1641237

This changed the bottom *) argument that used to pass through to httpd. Now it errors. Here is a dump from the log:

2019-04-14 15:03:41,947:DEBUG:certbot.main:certbot version: 0.31.0
2019-04-14 15:03:41,947:DEBUG:certbot.main:Arguments: [’–apache’]
2019-04-14 15:03:41,948:DEBUG:certbot.main:Discovered plugins: PluginsRegistry(PluginEntryPoint#apache,PluginEntryPoint#manual,PluginEntryPoint#null,PluginEntryPoint#standalone,PluginEntryPoint#webroot)
2019-04-14 15:03:41,997:DEBUG:certbot.log:Root logging level set at 20
2019-04-14 15:03:41,997:INFO:certbot.log:Saving debug log to /var/log/letsencrypt/letsencrypt.log
2019-04-14 15:03:41,999:DEBUG:certbot.plugins.selection:Requested authenticator apache and installer apache
2019-04-14 15:03:42,412:ERROR:certbot.util:Error while running apachectl -v.

apachectl: The “-v” option is not supported.

2019-04-14 15:03:42,414:DEBUG:certbot.plugins.disco:Other error:(PluginEntryPoint#apache): Unable to run [‘apachectl’, ‘-v’] -v
Traceback (most recent call last):
File “/usr/lib/python3.7/site-packages/certbot_apache/configurator.py”, line 2228, in get_version
stdout, _ = util.run_script(self.option(“version_cmd”))
File “/usr/lib/python3.7/site-packages/certbot/util.py”, line 86, in run_script
raise errors.SubprocessError(msg)
certbot.errors.SubprocessError: Error while running apachectl -v.

apachectl: The “-v” option is not supported.

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “/usr/lib/python3.7/site-packages/certbot/plugins/disco.py”, line 132, in prepare
self._initialized.prepare()
File “/usr/lib/python3.7/site-packages/certbot_apache/configurator.py”, line 239, in prepare
self.version = self.get_version()
File “/usr/lib/python3.7/site-packages/certbot_apache/configurator.py”, line 2232, in get_version
self.option(“version_cmd”))
certbot.errors.PluginError: Unable to run [‘apachectl’, ‘-v’] -v
2019-04-14 15:03:42,419:DEBUG:certbot.plugins.selection:No candidate plugin
2019-04-14 15:03:42,420:DEBUG:certbot.plugins.selection:No candidate plugin
2019-04-14 15:03:42,420:DEBUG:certbot.plugins.selection:Selected authenticator None and installer None
2019-04-14 15:03:42,420:INFO:certbot.main:Could not choose appropriate plugin: The apache plugin is not working; there may be problems with your existing configuration.
The error was: PluginError(“Unable to run [‘apachectl’, ‘-v’] -v”)
2019-04-14 15:03:42,422:DEBUG:certbot.log:Exiting abnormally:
Traceback (most recent call last):
File “/usr/bin/certbot”, line 11, in
load_entry_point(‘certbot==0.31.0’, ‘console_scripts’, ‘certbot’)()
File “/usr/lib/python3.7/site-packages/certbot/main.py”, line 1365, in main
return config.func(config, plugins)
File “/usr/lib/python3.7/site-packages/certbot/main.py”, line 1229, in certonly
installer, auth = plug_sel.choose_configurator_plugins(config, plugins, “certonly”)
File “/usr/lib/python3.7/site-packages/certbot/plugins/selection.py”, line 237, in choose_configurator_plugins
diagnose_configurator_problem(“authenticator”, req_auth, plugins)
File “/usr/lib/python3.7/site-packages/certbot/plugins/selection.py”, line 341, in diagnose_configurator_problem
raise errors.PluginSelectionError(msg)
certbot.errors.PluginSelectionError: The apache plugin is not working; there may be problems with your existing configuration.
The error was: PluginError(“Unable to run [‘apachectl’, ‘-v’] -v”)

I figured I could simply hack it a bit. So I put that argument back in and it just bombs further down when it does a configuration check. Difference between how it’s checking, it doesn’t see the loaded modules. If you fix that it still fails. Maybe this is a known issue?

Please let me know if I can help debug.

#2

Hi,

Could you please open the issue again at https://github.com/certbot/certbot/issues?
That would help certbot engineers better debug / make patches and keep track of issues.

Thank you

#3

There is one: